;Contributed by Charles Mc Auley, CompuServe ID = 73062,1420
;See README.TXT for Documentation

(defun  C:PSLOT ( / OLDOS MSG SP ORNT LEN DPTH BLG P1 P2 P3 P4)
   (setq OLDOS (getvar "OSMODE"))
   (setvar "OSMODE" 0)
   (setq MSG "\nPick slot center point: ")
   (initget 1)
   (setq SP (getpoint MSG))
   (initget 1 "Hor Vert")
   (setq MSG "\nSlot orientation - Hor/Vert: ?")
   (setq ORNT (getkword MSG))
   (initget (+ 1 2 4))
   (setq MSG "\nSlot Length: "
         LEN (getreal MSG)
   );setq
   (initget (+ 1 2 4))
   (setq MSG "\nSlot Width: "
         DPTH (getreal MSG)
   );setq
   (setq BLG 1.0)
   (cond
      ((= ORNT "Hor")
         (setq P1 (mapcar '+ (list (* (/ (- LEN DPTH) 2.0) -1.0) ;X-val
                                   (* (/ DPTH 2.0) -1.0);Y-val
                                   0 ;Z
                             ) SP ;Reference Point SP
                  )
               P2 (mapcar '+ (list (- LEN DPTH) 0 0) P1)
               P3 (mapcar '+ (list 0 DPTH 0) P2)
               P4 (mapcar '+ (list 0 DPTH 0) P1)
         );setq
      );Horizontal
      ((= ORNT "Vert")
         (setq P1 (mapcar '+ (list (/ DPTH 2.0);X-val
                                   (* (/ (- LEN DPTH) 2.0) -1.0);Y-val
                                   0 ;Z
                             ) SP ;Reference Point SP
                  )
               P2 (mapcar '+ (list 0 (- LEN DPTH) 0) P1)
               P3 (mapcar '+ (list (* DPTH -1.0) 0 0) P2)
               P4 (mapcar '+ (list (* DPTH -1.0) 0 0) P1)
         );setq
      );Horizontal
   );cond
   (entmake (list (cons 0 "POLYLINE")))
   (entmake (list (cons 0 "VERTEX") (cons 10 P1)))
   (entmake (list (cons 0 "VERTEX") (cons 10 P2)(cons 42 BLG)))
   (entmake (list (cons 0 "VERTEX") (cons 10 P3)))
   (entmake (list (cons 0 "VERTEX") (cons 10 P4)(cons 42 BLG)))
   (entmake (list (cons 0 "VERTEX") (cons 10 P1)))
   (entmake (list (cons 0 "SEQEND")))
   (setvar "OSMODE" OLDOS)
   (princ)
);End of defun PSLOT

(prompt "C:PSLOT - Polyline slot type PSLOT to execute.")
(princ)