;Contributed by Charles Mc Auley, CompuServe ID = 73062,1420
;See README.TXT for Documentation

(defun C:MPSLOT ( / INDEX_VAL GO OLDOS MSG SP ORNT LEN DPTH SPLIST)
   (if (> (setq INDEX_VAL (load_dialog "pslot")) 0)
      (if (new_dialog "pslot" INDEX_VAL)
         (progn
            (setq ORNT "Hor")

            (set_tile "header" "Multiple Polyline SLOTS")
            (start_image "hor")
            (fill_image 0 0 (dimx_tile "hor") (dimy_tile "hor") 0)
            (end_image)
            (start_image "hor")
            (slide_image 0 0 (dimx_tile "hor") (dimy_tile "hor") "PSLOTH")
            (end_image)

            (start_image "ver")
            (fill_image 0 0 (dimx_tile "ver") (dimy_tile "ver") 0)
            (end_image)
            (start_image "ver")
            (slide_image 0 0 (dimx_tile "ver") (dimy_tile "ver") "PSLOTV")
            (end_image)

            (action_tile "hor" "(get_hor)")
            (action_tile "ver" "(get_ver)")
            (action_tile "len" "(get_len)")
            (action_tile "wth" "(get_wth)")
            (action_tile "accept" "(chk_vals) (done_dialog 1)")
            (action_tile "cancel" "(setq GO nil) (done_dialog 0)")
            (start_dialog)

            (if GO
               (progn
                  (setq OLDOS (getvar "OSMODE"))
                  (setvar "OSMODE" 0)
                  (setq MSG "\nPick SLOT center points, ENTER when done: ")
                  (prompt MSG)
                  (while (setq SP (getpoint))
                     (setq SPLIST (append SPLIST (list SP)))
                  );while
                  (setq COUNT 0)
                  (repeat (length SPLIST)
                     (setq SP (nth COUNT SPLIST))
                     (do_slot SP ORNT LEN DPTH)
                     (setq COUNT (1+ COUNT))
                  );repeat
                  (setvar "OSMODE" OLDOS)
                  (princ)
               );progn
            );if
         );progn - Then
         (alert "Unable to display Dialog Box");Else
      );if - Then
      (alert "Unable to open Dialog Box");Else
   );if
   (unload_dialog INDEX_VAL)
   (princ)
);End of defun PSLOT

(defun GET_HOR ()
   (setq ORNT "Hor")
);End of defun GET_HOR

(defun GET_VER ()
   (setq ORNT "Ver")
);End of defun GET_VER

(defun GET_LEN ()
   (if (/= (setq LEN (atof (get_tile "len"))) 0.0)
      (setq GO T);Then
      (progn
         (alert "Invalid data type or\na 0 value entered or\nno entry for LENGHT")
         (setq GO nil)
      );progn - Else
   );if
);End of defun GET_LEN

(defun GET_WTH ()
   (if (/=  (setq DPTH (atof (get_tile "wth"))) 0.0)
      (setq GO T);Then
      (progn
         (alert "Invalid data type or\na 0 value entered or\nno entry for WIDTH")
         (setq GO nil)
      );progn - Else
   );if
);End of defun GET_WTH

(defun CHK_VALS ()
   (if (not (and ORNT LEN DPTH GO))
      (progn
         (setq GO nil)
         (alert "Invalid or no data input")
      );progn - Then
   );if
);End of defun CHK_VALS


(defun  DO_SLOT ( SP ORNT LEN DPTH / BLG P1 P2 P3 P4)
   (setq BLG 1.0)
   (cond
      ((= ORNT "Hor")
         (setq P1 (mapcar '+ (list (* (/ (- LEN DPTH) 2.0) -1.0) ;X-val
                                   (* (/ DPTH 2.0) -1.0);Y-val
                                   0 ;Z
                             ) SP ;Reference Point SP
                  )
               P2 (mapcar '+ (list (- LEN DPTH) 0 0) P1)
               P3 (mapcar '+ (list 0 DPTH 0) P2)
               P4 (mapcar '+ (list 0 DPTH 0) P1)
         );setq
      );Horizontal
      ((= ORNT "Ver")
         (setq P1 (mapcar '+ (list (/ DPTH 2.0);X-val
                                   (* (/ (- LEN DPTH) 2.0) -1.0);Y-val
                                   0 ;Z
                             ) SP ;Reference Point SP
                  )
               P2 (mapcar '+ (list 0 (- LEN DPTH) 0) P1)
               P3 (mapcar '+ (list (* DPTH -1.0) 0 0) P2)
               P4 (mapcar '+ (list (* DPTH -1.0) 0 0) P1)
         );setq
      );Horizontal
   );cond
   (entmake (list (cons 0 "POLYLINE")))
   (entmake (list (cons 0 "VERTEX") (cons 10 P1)))
   (entmake (list (cons 0 "VERTEX") (cons 10 P2)(cons 42 BLG)))
   (entmake (list (cons 0 "VERTEX") (cons 10 P3)))
   (entmake (list (cons 0 "VERTEX") (cons 10 P4)(cons 42 BLG)))
   (entmake (list (cons 0 "VERTEX") (cons 10 P1)))
   (entmake (list (cons 0 "SEQEND")))
   (princ)
);End of defun DO_SLOT

(prompt "C:MPSLOT - Multiple Polyline slots type MPSLOT to execute.")
(princ)